//A separate copy of the cycles variable is created on each thread's memory stack, and so the output is, predictably, 
//ten question marks.

//Threads share data if they have a common reference to the same object instance. For example:

using System;
using System.Threading;

class ThreadTest
{
  bool done;
 
  static void Main()
  {
    ThreadTest tt = new ThreadTest();   // Create a common instance
    new Thread (tt.Go).Start();
    tt.Go();
  }
 
  // Note that Go is now an instance method
  void Go() 
  {
     if (!done) 
	 { 
		done = true; 
		Console.WriteLine ("Done"); 
	 }
  }
}

//Because both threads call Go() on the same ThreadTest instance, they share the done field. This results in "Done" being printed once instead of twice:
